'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactCodemirror = require('react-codemirror2');

var _codemirror = require('codemirror/lib/codemirror');

var _codemirror2 = _interopRequireDefault(_codemirror);

var _parse2 = require('./parse');

var _parse3 = _interopRequireDefault(_parse2);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var STATUS_IDLE = 'idle';
var STATUS_PLAY = 'play';
var STATUS_PAUSE = 'pause';

var requestTimer = function requestTimer(fn, delay) {
  if (!delay) {
    fn();
  } else {
    return setTimeout(fn, delay);
  }
};

var Movie = function (_React$Component) {
  _inherits(Movie, _React$Component);

  function Movie() {
    var _ref,
        _this2 = this;

    var _temp, _this, _ret;

    _classCallCheck(this, Movie);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Movie.__proto__ || Object.getPrototypeOf(Movie)).call.apply(_ref, [this].concat(args))), _this), _this.editor = null, _this.state = {
      status: STATUS_IDLE,
      queue: [],
      actions: [],
      index: 0
    }, _this.updateState = function (data) {
      return new Promise(function (resolve) {
        return _this.setState(data, resolve);
      });
    }, _this.initMovie = function () {
      if (!('preventCursorMovement' in _codemirror2.default.defaults)) {
        _codemirror2.default.defineOption('preventCursorMovement', false, function (cm) {
          var handler = function handler(cm, event) {
            return cm.getOption('readOnly') && event.preventDefault();
          };
          cm.on('keydown', handler);
          cm.on('mousedown', handler);
        });
      }

      var editor = _this.editor;

      var initialValue = editor.getValue() || '';

      var _parse = (0, _parse3.default)(initialValue),
          value = _parse.value,
          actions = _parse.actions;

      // normalize line endings


      value = value.replace(/\r?\n/g, '\n');

      var initialPos = value.indexOf('|');

      value = value.replace(/\|/g, '');
      editor.setValue(value);

      if (initialPos !== -1) {
        editor.setCursor(editor.posFromIndex(initialPos));
      }

      _this.setState({
        actions: actions
      });
    }, _this.toggle = function () {
      if (_this.state.status === STATUS_PLAY) {
        _this.pause();
      } else {
        _this.play();
      }
    }, _this.runQueue = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
      var timerObj, fn, delay;
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              timerObj = _this.state.queue[0];

              if (timerObj) {
                _context.next = 3;
                break;
              }

              return _context.abrupt('return');

            case 3:
              fn = timerObj.fn, delay = timerObj.delay;

              requestTimer(fn, delay);

              _context.next = 7;
              return _this.updateState({
                queue: _this.state.queue.slice(1)
              });

            case 7:
              _context.next = 9;
              return _this.runQueue();

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, _this2);
    })), _this.play = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              if (!(_this.state.status === STATUS_PLAY)) {
                _context2.next = 2;
                break;
              }

              return _context2.abrupt('return');

            case 2:
              if (!(_this.state.status === STATUS_PAUSE)) {
                _context2.next = 9;
                break;
              }

              // revert from paused state
              _this.editor.focus();

              _context2.next = 6;
              return _this.updateState({
                status: STATUS_PLAY
              });

            case 6:
              _context2.next = 8;
              return _this.runQueue();

            case 8:
              return _context2.abrupt('return');

            case 9:
              if (_this.state.actions.length) {
                _context2.next = 12;
                break;
              }

              _this.finish();
              return _context2.abrupt('return');

            case 12:

              _this.editor.execCommand('revert');
              _this.editor.setOption('readOnly', true);
              _this.editor.focus();

              _context2.next = 17;
              return _this.updateState({
                status: STATUS_PLAY
              });

            case 17:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, _this2);
    })), _this.pause = function () {
      if (_this.state.status === STATUS_PLAY) {
        _this.setState({
          status: STATUS_PAUSE
        });
      }
    }, _this.finish = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.next = 2;
              return _this.resetState();

            case 2:
              _context3.next = 4;
              return _this.props.onFinish();

            case 4:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, _this2);
    })), _this.stop = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              _context4.next = 2;
              return _this.resetState();

            case 2:
              _context4.next = 4;
              return _this.props.onStop();

            case 4:
            case 'end':
              return _context4.stop();
          }
        }
      }, _callee4, _this2);
    })), _this.resetState = function () {
      _this.editor.setOption('readOnly', false);

      return new Promise(function (r) {
        _this.setState({
          status: STATUS_IDLE,
          queue: [],
          index: 0
        }, r);
      });
    }, _this.requestTimer = function (fn, delay) {
      if (_this.state.status !== STATUS_PLAY) {
        // save function call into a queue till next 'play()' call
        _this.setState({
          queue: [].concat(_toConsumableArray(_this.state.queue), [{ fn: fn, delay: delay }])
        });
      } else {
        return requestTimer(fn, delay);
      }
    }, _this.handleActionChange = function (index) {
      _this.setState({
        index: index
      });
    }, _this.renderAction = function () {
      var _this$state = _this.state,
          actions = _this$state.actions,
          index = _this$state.index;

      if (actions.length === 0) {
        return null;
      }

      var action = actions[index];
      if (!action) {
        return null;
      }

      if (action.name !== 'tooltip') {
        return null;
      }

      return _react2.default.createElement(_Tooltip2.default, {
        options: action.options,
        editor: _this.editor,
        index: index,
        total: actions.length,
        onActionChange: _this.handleActionChange,
        onStop: _this.stop,
        onFinish: _this.finish,
        timer: _this.requestTimer,
        customClasses: _this.props.tooltipClasses
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Movie, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initMovie();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (prevProps.value !== this.props.value) {
        this.initMovie();
        return;
      }

      if (this.props.playing) {
        if (!prevProps.playing) {
          this.play();
        }
      } else {
        if (prevProps.playing) {
          this.pause();
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var _props = this.props,
          className = _props.className,
          code = _props.code,
          commands = _props.commands;


      var script = code;
      if (commands && commands.length) {

        var cmdsString = commands.map(function (one) {
          return one.type + ': ' + JSON.stringify(one.options);
        }).join('\n');

        script += '\n@@@\n' + cmdsString + '\n';
      }

      var defaultOptions = {
        mode: 'text/x-java',
        theme: 'seti',
        lineNumbers: true,
        lineWrapping: true,
        readOnly: false,
        autoRefresh: true,
        showCursorWhenSelecting: false
      };

      var options = _extends({}, defaultOptions, this.props.options);

      return _react2.default.createElement(
        'div',
        { className: className },
        this.state.status !== STATUS_IDLE && this.renderAction(),
        _react2.default.createElement(_reactCodemirror.UnControlled, {
          editorDidMount: function editorDidMount(editor) {
            _this3.editor = editor;
          },
          value: script,
          options: options
        })
      );
    }
  }]);

  return Movie;
}(_react2.default.Component);

exports.default = Movie;